Subject: bug#79128: 31.0.50; shortdoc doesn't always display the correct arglist

From: Eli Zaretskii <[email-masked]>
Date: Fri, 01 Aug 2025 10:43:24 +0300

> From: Robert Pluim <[email-masked]>
> Date: Wed, 30 Jul 2025 15:26:08 +0200
> 
> 
> emacs -Q
> (require 'shortdoc)
> (shortdoc 'sequence)
> 
> The entry for e.g. `seq-empty-p' says:
> 
>     (seq-empty-p arg &rest args)
>       Return non-nil if the SEQUENCE is empty, nil otherwise.
>       (seq-empty-p [])
>         ⇒ t
> 
> But C-h f seq-empty-p says:
> 
>     seq-empty-p is a byte-code-function in ‘seq.el’.
> 
>     (seq-empty-p SEQUENCE)
> 
>     Return non-nil if the SEQUENCE is empty, nil otherwise.
> 
>       Other relevant functions are documented in the sequence group.
> 
> 
>     This is a generic function.
> 
>     Implementations:
> 
>     (seq-empty-p (LIST list)) in ‘seq.el’.
> 
>     Optimized implementation of ‘seq-empty-p’ for lists.
> 
>     (seq-empty-p SEQUENCE) in ‘seq.el’.
> 
>     Undocumented
> 
> I imagine this is some interaction between `cl-defgeneric' with an
> implementation body, `cl-defmethod', and `help-function-arglist' (other
> functions in  the 'sequence group are also affected). C-h f gets it
> right, but I couldnʼt find a simple function in help-fns.el to get me
> the actual arglist.

Sorry, I'm confused wrt what is the bug/issue you are reporting here.
Are you saying that shortdoc is wrong in what it says?  If so, please
elaborate why, because I see nothing wrong with what it says, given
that shortdoc is supposed to be, well, short.